<template>
  <pageWrapper
    :title="$t(activeComponent+'.title')"
    backable
    gradient
    @close="close"
    ref="pageWrapper"
    @back="back">
    <div
      class="fullHistory scroll-container"
      ref="container">
      <div class="fullHistory_header fullHistory_menu">
        <div
          class="fullHistory_menu-item"
          :class="activeComponent === 'history' ? 'active' : ''"
          @click="changeComponent('history')">
          <div class="fullHistory_menu-item-icon">
            <IconFile :fill="activeComponent === 'history' ? '#00bac3' : '#8f9095'"></IconFile>
          </div>
          <div class="fullHistory_menu-item-text">{{$t('history.title')}}</div>
        </div>
        <div
          class="fullHistory_menu-item"
          :class="activeComponent === 'champions' ? 'active' : ''"
          @click="changeComponent('champions')">
          <div class="fullHistory_menu-item-icon">
            <IconStar :fill="activeComponent === 'champions' ? '#fea911' : '#8f9095'"></IconStar>
          </div>
          <div class="fullHistory_menu-item-text">{{$t('champions.title')}}</div>
        </div>
        <div
          class="fullHistory_menu-item"
          :class="activeComponent === 'commissions' ? 'active' : ''"
          @click="changeComponent('commissions')">
          <div class="fullHistory_menu-item-icon">
            <IconChart :fill="activeComponent === 'commissions' ? '#3c8af4' : '#8f9095'"></IconChart>
          </div>
          <div class="fullHistory_menu-item-text">{{$t('commissions.title')}}</div>
        </div>
        <div
          class="fullHistory_menu-item"
          :class="activeComponent === 'advMaterials' ? 'active' : ''"
          @click="changeComponent('advMaterials')">
          <div class="fullHistory_menu-item-icon">
            <IconSpeaker :fill="activeComponent === 'advMaterials' ? '#36d153' : '#8f9095'"></IconSpeaker>
          </div>
          <div class="fullHistory_menu-item-text">{{$t('advMaterials.title')}}</div>
        </div>
      </div>
      <components
        :is="activeComponent"></components>
    </div>
    <BackToTop
      v-show="showBackToTop"
      @click="scrollToTop"
      ref="backToTop"></BackToTop>
  </pageWrapper>
</template>

<script>
  import pageWrapper from '~/components/common/pageWrapper';

  import History from './components/history/';
  import Champions from './components/champions/';
  import Commissions from './components/commissions/';
  import AdvMaterials from './components/advmaterials/';

  import IconStar from './icon-star';
  import IconSpeaker from './icon-speaker';
  import IconFile from './icon-file';
  import IconChart from './icon-chart';

  import HistoryBody from '~/components/history/History_body_full';

  import BackToTop from '~/components/common/backToTop';
  import {scrollTo} from '~/components/utils/';

  export default {
    name: "FullHistory",
    data() {
      return {
        activeComponent: 'history',
        showBackToTop: true
      }
    },
    components: {
      pageWrapper,
      History,
      Champions,
      Commissions,
      IconStar,
      IconSpeaker,
      IconFile,
      IconChart,
      AdvMaterials,
      HistoryBody,
      BackToTop
    },
    methods: {
      changeComponent(name) {
        switch (name) {
          case 'history': {
            this.showBackToTop = true;
            this.ga('fh');
            break;
          }
          case 'champions': {
            this.showBackToTop = true;
            this.ga('champ');
            break;
          }
          case 'commissions': {
            this.showBackToTop = true;
            this.ga('comi');
            break;
          }
          case 'advMaterials': {
            this.showBackToTop = false;
            this.ga('promo');
            break;
          }
        }
        this.activeComponent = name;
      },
      back() {
        this.ga('back', true);
        this.$emit('close');
      },
      close() {
        this.$emit('closeAll');
      },
      scrollToTop() {
        scrollTo(this.$refs['pageWrapper'].$el, 0, 250)
      }
    },
    mounted() {
      this.$onWrapperScroll.setContainer(this.$refs['pageWrapper'].$el);
      this.$refs['pageWrapper'].$el.onscroll = (e) => {
        if (this.$refs['pageWrapper'].$el.scrollTop > 200) {
          this.$refs['backToTop'].show();
          if (this.$refs['pageWrapper'].$el.scrollHeight - this.$refs['pageWrapper'].$el.scrollTop < 745) {
            this.$refs['backToTop'].bottom = 150 - (this.$refs['pageWrapper'].$el.scrollHeight - this.$refs['pageWrapper'].$el.scrollTop - 613);
          } else {
            this.$refs['backToTop'].bottom = 20;
          }
        } else {
          this.$refs['backToTop'].hide();
        }
        this.$onWrapperScroll.scroll(e);
      };
    }
  }
</script>
